image: node:14

stages:
    - build
    - test
    - deploy staging
    - deploy production
    - production tests

cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
        - node_modules/

variables:
    STAGING_DOMAIN: jealous-cast-staging.surge.sh
    PRODUCTION_DOMAIN: jealous-cast.surge.sh

build website:
    stage: build
    script:
        - echo $CI_COMMIT_SHORT_SHA
        - npm install
        - npm install -g gatsby-cli
        - gatsby build
        - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./public/index.html
    artifacts:
        paths:
        - ./public

test artifact:
    image: alpine
    stage: test
    script:
        - grep -q "Gatsby" ./public/index.html

test website:
    stage: test
    script:
        - npm install
        - npm install -g gatsby-cli
        - gatsby serve &
        - sleep 3
        - curl "http://localhost:9000" | tac | tac | grep -q "Gatsby"

deploy staging: 
    stage: deploy staging
    environment:
        name: staging
        url: http://$STAGING_DOMAIN
    only:
        - master  
    script:
        - npm install --global surge
        - surge --project ./public --domain $STAGING_DOMAIN

deploy production: 
    stage: deploy production
    environment:
        name: production
        url: $PRODUCTION_DOMAIN
    only:
        - master    
    script:
        - npm install --global surge
        - surge --project ./public --domain $PRODUCTION_DOMAIN

production tests:
    image: alpine
    stage: production tests
    only:
        - master  
    script:
        - apk add --no-cache curl
        - curl -s "https://$PRODUCTION_DOMAIN" | grep -q "Hi people"
        - curl -s "https://$PRODUCTION_DOMAIN" | grep -q "$CI_COMMIT_SHORT_SHA"
